#include <bits/stdc++.h>
using namespace std;

typedef long long int ll;
typedef pair<int, int> pii;
bool R(){return true;}
template<typename T, typename ... Args>
bool R(T & x, Args & ... args){return cin >> x && R(args...);}
void init_io(){ios::sync_with_stdio(false);cin.tie(0);}

#define PB push_back
#define FOR(prom, a, b) for(int prom = (a); prom < (b); prom++)
#define FORDE(prom, a, b) for(int prom = (a); prom >= (b); prom--)
#define ALL(vec) (vec).begin(), (vec).end()
#define MM(co, cim) memset((co), (cim), sizeof((co)))
#define DEB(x) cerr << ">>> " << #x << " : " << x << endl;
#define INF   1000000007
#define INFLL 4000000000000000007LL

#define MAX_INPUT_SIZE  100
#define MAX_OUTPUT_SIZE 3000

int n, m;
string s;
char grid[MAX_INPUT_SIZE + 14][MAX_INPUT_SIZE + 14], out[MAX_OUTPUT_SIZE + 14][MAX_OUTPUT_SIZE + 14];
map<int, char> chars = {{0, '#'}, {1, '.'}};

string parse (int si, int sj, int chari)
{
  set<pii> togo;
  queue<pii> q;
  q.push({si, sj});
  grid[si][sj] = '$';
  while (!q.empty())
  {
    pii cc = q.front();
    q.pop();
    int ci = cc.first;
    int cj = cc.second;
    FOR(di, -1, 2) FOR(dj, -1, 2) if (di * di + dj * dj == 1)
    {
       int ni = ci + di;
       int nj = cj + dj;
       if (grid[ni][nj] != '$')
       {
         if (grid[ni][nj] == chars[chari]) 
         {
           grid[ni][nj] = '$';
           q.push({ni, nj});
         }
         else togo.insert({ni, nj});
       }
    }
  }
  string res;
  int total = 0;
  for (auto en : togo) if (grid[en.first][en.second] != '$')
  {
    res += parse(en.first, en.second, 1 - chari);
    ++total;
  }
  if (total) res = ((char)(total + 'a' - 1)) + res;
  return res;
}

void output (int fromi, int toi, int fromj, int toj, int chari, int index)
{
  FOR(j, fromj, toj) out[fromi][j] = out[toi - 1][j] = chars[chari];
  FOR(i, fromi, toi) out[i][fromj] = out[i][toj - 1] = chars[chari];
  if (index < s.length())
  {
    int num_inner = (int)s[index] - 'a' + 1;
    int from_inner_i = fromi + 1;
    int to_inner_i = toi - 1;
    int from_inner_j = fromj + 1;
    int to_inner_j = toj - 1;
    if (num_inner > 1)
    {
      FOR(j, from_inner_j, to_inner_j) out[from_inner_i][j] = out[from_inner_i + 1][j] = chars[chari];
      FOR(k, 0, num_inner - 1) out[from_inner_i][from_inner_j + 2 * k] = chars[1 - chari];
      from_inner_i += 2;
    }
    return output(from_inner_i, to_inner_i, from_inner_j, to_inner_j, 1 - chari, index + 1);
  }
  else
  {
    FOR(i, fromi, toi) FOR(j, fromj, toj) out[i][j] = chars[chari];
  }
}

void solve ()
{
  R(n, m);
  FOR(i, 0, n + 2) FOR(j, 0, m + 2) grid[i][j] = '$';
  FOR(i, 1, n + 1) FOR(j, 1, m + 1) R(grid[i][j]);
  
  s = parse(1, 1, 0);
  reverse(ALL(s));
  
  output(1, MAX_OUTPUT_SIZE + 1, 1, MAX_OUTPUT_SIZE + 1, 0, 0);
  
  printf("%d %d\n", MAX_OUTPUT_SIZE, MAX_OUTPUT_SIZE);
  FOR(i, 1, MAX_OUTPUT_SIZE + 1) FOR(j, 1, MAX_OUTPUT_SIZE + 1) printf("%c%s", out[i][j], j == MAX_OUTPUT_SIZE ? "\n": "");
}

int main ()
{
  init_io();
  int T = 1;
  //R(T);
  while (T--) solve();
  return 0;
}
